// CMatrix.java <- Animation05/28/1996 uyarlandi.
// $Id$
// $Log$

import java.awt.*;
import java.lang.Math.*;
import java.io.*;
import java.net.*;
import java.util.*;






//*===========================
//* MatrixPanel
//*===========================
class MatrixPanel extends Panel implements Runnable {
   boolean inAnApplet = true;
   boolean sim_completed = false;
   int simTime = 0;
  int labelXPos, labelYPos;  
   int nodeX,nodeY, nodeH;
   boolean stepFlag;
   int panelW = 640;
   int panelH;
   // Chart params
   int chartW, chartH, chartX, chartY;
   int xGap, yGap;

   Font        titleF, labelF;
   FontMetrics titleFm, labelFM;
   String      title, labelX, labelY;

   Image offscreen;
   Dimension offscreensize;
   Graphics offgraphics;

   TwoDArrayObject array = new TwoDArrayObject();


   int curIter;
  //------------- Wrapper definitions
  char ch,chr;
          static public recv_module   con;
          int intval;
          char charval;
          float floatval,far[]=new float[5];       
          int ii[] =new int[32],dims[]=new int[1];
          String str;  
          int [][]i2dar;
   String hpf_host = "osprey7.npac.syr.edu";
   int    hpf_port = 3336;
  
   //-------------------------------------------
  float [][] data = new float[16][16];
  

   MatrixPanel(CMatrix graph){

   //  con = new recv_module(hpf_host, hpf_port);
   //  try {
   //    con.open_connection();
   //  }
   //  catch (IOException e) {
   //   System.out.println("IO Exception in TwoDArrayObject()"); 
   //  }
   //  System.out.println("after connection to port  "+hpf_port); 
   //  System.out.println("after connection to host  "+hpf_host);  
 
     resetSimulation();

   }


   //--------------------------------------------
   public void resetSimulation() {
      sim_completed = false;
      //resetChart();
      simTime = 0;
      curIter=0;

   //---- recv_data(name, dim1, dim2, type, data);

   }

   //--------------------------------------------
   public void run() {
        while (simTime++ < 921) {
            repaint();
	        try {
                Thread.sleep(1000);
	        } catch (InterruptedException e) {
                break;
	        }
            Thread.yield();
         
        }
   }
   //--------------------------------------------
   public void paintNodes(Graphics g, FontMetrics fm) {
      int x, y;
      for (int i=0; i<array.dim1; i++)
         for (int j=0; j<array.dim2; j++) {
            y = chartY + yGap* j;
            x = chartX + xGap* i; //(int)(Math.random()*array.dim1);
            g.setColor(array.color[i][j]);
            g.fillRect(x+1, y+1, xGap-2, yGap-2);
         }
   }
   //--------------------------------------------
   public void resetChart() {
      xGap = 20;
      yGap = 20;
      chartW = xGap*array.dim1;
      chartH = yGap*array.dim2;
      chartX = (panelW - chartW)/2;
      labelXPos = chartX;
      labelYPos = 10;
      chartY = labelYPos + 30;
      System.out.println(xGap+":"+yGap+":"+chartX+":"+chartY+":"+chartW+":"+chartH);
      
      
   }
   public void drawChart(Graphics g) {
     resetChart();
     
      g.setColor(Color.black);
      g.drawRect(chartX, chartY, chartW, chartH);
      int y = chartY;
      for (int i=0; i<array.dim1; i++) {
          g.drawLine(chartX, y, chartX+chartH, y);
          y += yGap;
      }
      int x = chartX;
      for (int i=0; i<array.dim2; i++) {
          g.drawLine(x, chartY, x, chartY+chartW);
          x += xGap;
      }

      putTics(g); 
   }

  //-------------------------------------------
  // Puts x and y axis tics.
  //-------------------------------------------
   public void putTics(Graphics g) {
      int x, y, yoff;
      int dim1 = array.dim1;
      int dim2 = array.dim2;
      int labelW, labelH;
      String xticLabel, yticLabel;
      
      labelF = new Font("Helvetica", Font.PLAIN, 10);
      g.setFont(labelF);
      labelFM = g.getFontMetrics(labelF); 
      int ticLabelH = labelFM.getHeight();

      g.setColor(Color.black);       
      g.setFont(labelF);

      //String label = "www";
      
      //--- Put x axis tics
      //
      x = chartX;
      y = chartY; 
      for (int i=array.lb2; i<array.ub2; i++) {
	xticLabel = ""+String.valueOf(i);
	labelW = labelFM.stringWidth(xticLabel);
        g.drawString(xticLabel, x, y-ticLabelH); 
	x = chartX + i * xGap + (xGap - labelW) /2;
      }
      //--- Put y axis tics
      //
      x = chartX;
      y = chartY; 
      yoff= (yGap-ticLabelH)/2 + ticLabelH; 
    
      for (int i=array.lb1; i<array.ub1; i++) {
	yticLabel = ""+String.valueOf(i); 
        labelW = labelFM.stringWidth(yticLabel);
        x = chartX - labelW - 2;
        g.drawString(yticLabel, x, y+yoff);
        y += yGap;
      }
      g.drawString(array.name,labelXPos, labelYPos);       
   }
   //--------------------------------------------
   public synchronized void update(Graphics g) {
	   Dimension d = size();
	   if ((offscreen == null)) {
	      // || (d.width != offscreensize.width) || (d.height != offscreensize.height)) {
	      //offscreen = createImage(d.width, d.height);
	      offscreen = createImage(1000,1000);
	      offscreensize = d;
	      offgraphics = offscreen.getGraphics();
	      offgraphics.setFont(getFont());
	   }
	   offgraphics.setColor(getBackground());
	   offgraphics.fillRect(0, 0, d.width, d.height);

	   FontMetrics fm = offgraphics.getFontMetrics();
System.out.println("Updating ....");
doSimulation();

try{
  
  array.recv_data(con);
}
catch (IOException e) {
      System.out.println("IO Exception in CMatrix - update()"); 
    }
      drawChart(offgraphics);
      paintNodes(offgraphics, fm);      
      g.drawImage(offscreen, 0, 0, null);
   }
   //--------------------------------------------
   public void doSimulation() {
      boolean notDone;

      if (!sim_completed) {
         try {
               Thread.sleep((int)(1000));
         }
         catch (InterruptedException ie1) {
		         System.out.println("exception:  " +ie1.toString());
	      }
         //Thread.yield();

      }
      else {  //if (!notDone) {
         Thread.yield();
         sim_completed = true;
      }
   }
}

//*====================================
//* CMatrix
//*====================================
public class CMatrix extends Frame {

   MatrixPanel panel;
   int simTime = 0;
   final String FILE_BUTTON    = " Display data";
   final String EXIT_BUTTON    = "  Exit ";
   final String RESTART_BUTTON = " Reset ";
   final String STEP_BUTTON    = "  Step   ";
   final String RESUME_BUTTON  = "  Resume ";
   final String START_BUTTON = " Start ";
   final String PARAM_BUTTON = " Parameters ";
   Thread aThread;

   final String HELP_MENU = " Help ";
   final String HMENU_help= " Help ";
   String hpf_host = "merlin2.npac.syr.edu";
   //osprey1.npac.syr.edu";
   int    hpf_port = 3336;
   network nt;
   

   static public recv_module con;


   static public void Open_port(String hpf_host,int hpf_port) {

     con = new recv_module(hpf_host, hpf_port);

     boolean done = false;
     while(!done)
     { 
        try {
          con.open_connection();
          done = true;
        }
        catch (IOException e) {
          System.out.println("IO Exception CMatrix");
          done = false;
        }
     }
     System.out.println("after connection to port  "+hpf_port); 
     System.out.println("after connection to host  "+hpf_host);  
   }



   public CMatrix() {
 
    
      setLayout(new BorderLayout());
      panel = new MatrixPanel(this);
      add("Center", panel);
      Panel p = new Panel();
      add("South", p);
      p.add(new Button(FILE_BUTTON));
      p.add(new Button(RESTART_BUTTON));
      p.add(new Button(STEP_BUTTON));
      p.add(new Button(EXIT_BUTTON));
      p.add(new Button(START_BUTTON));  
      p.add(new Button(PARAM_BUTTON));

      MenuBar mb = new MenuBar();
      Menu hm = new Menu(HELP_MENU);
      hm.add(new MenuItem(HMENU_help));
      mb.add(hm);
      setMenuBar(mb);
     //  aThread = new Thread(panel);
     //  aThread.start();

      network nt = new network("merlin2.npac.syr.edu",3333);
      //osprey1.npac.syr.edu", 3333);
      String cmd = "fork.pl";
      nt.send_http_command(cmd);  
      Open_port(hpf_host,3336); // hpf_port);
      MatrixPanel.con = con;           
      aThread = new Thread(panel);
      aThread.start();
      new read_from_http_server (nt).start();


   }
   //--------------------------------------------
   public boolean handleEvent(Event evt) {
      if (evt.id == Event.WINDOW_DESTROY) System.exit(0);
      return super.handleEvent(evt);
   }
   //--------------------------------------------
  
   public boolean action(Event evt, Object arg) {
      System.out.println("in action()");
      if (evt.target instanceof Button) {
         if (arg.equals(START_BUTTON)) {
           //network nt = new network("merlin2.npac.syr.edu",3333);
           //osprey1.npac.syr.edu", 3333);
           String cmd = "fork.pl";
           //nt.send_http_command(cmd);  
           Open_port(hpf_host,3336); // hpf_port);
           MatrixPanel.con = con;           
           aThread = new Thread(panel);
           aThread.start();
           //new read_from_http_server (nt).start();
         }
         else if (arg.equals(PARAM_BUTTON)) {
     
         }
        
         else if (arg.equals(EXIT_BUTTON)) {
            try {
                  con.close_connection();  
             }
             catch (IOException e) {
                 System.out.println("IO Exception in Exit closing socket");
             }
             nt.send_http_command("kill.pl");
             System.out.println("Exit");
	    
            if (panel.inAnApplet) {
               System.out.println("Disposing");
               dispose();
               return(true);
            } else
               System.exit(0);
          } else if (arg.equals(RESTART_BUTTON)) {
            System.out.println("Restart");
            panel.resetSimulation();
          } else if (arg.equals(FILE_BUTTON)) {
	    //PrintArray aWindow = new PrintArray(array);
	    //aWindow.setTitle("Array Data Display");
	    //aWindow.resize(640,640);
	    //aWindow.show();
          }
          else
             return super.action(evt, arg);
          return true;
       } else if (evt.target instanceof MenuItem) {
           if (arg.equals(HMENU_help)) {
             //HelpFrame hframe = new HelpFrame(6);
             //hframe.show();
           } else {
             return super.action(evt, arg);
           }
       } else {
          System.out.println("What ?");
          System.out.println("done");
          return super.action(evt, arg);
       }
       return true;
   }
   //--------------------------------------------
   public static void main(String args[]) {
      CMatrix aWindow = new CMatrix();
      aWindow.panel.inAnApplet = false;
      aWindow.setTitle("Laplace Matrix");
      aWindow.pack();
      aWindow.resize(640,700);
      aWindow.show();
   }
}
//===============================================


class network {
  
    private Socket s;
    private String host;
    private int port; 
    DataOutputStream os ;
    DataInputStream is;

   public  void send_http_command(String cmd)
   {

      String sdata = "Erol Akarsu";  
      String script = "/cgi-bin/"+cmd;
      System.out.println("Before communicate ");
      communicate(sdata,script);
      System.out.println("After  communicate ");
    }
   
    public network(String hostName,int portNo) {
      host = hostName;
      port = portNo;
      try {

        s  = new Socket(host, port);
        os = new DataOutputStream(s.getOutputStream());
        is = new DataInputStream(s.getInputStream());
      }catch (IOException e) {
        System.out.println("Io exception in network ");
      }  

      System.out.println("After opening socket to server ");  

    }

    public void  communicate (String sdata, String script)
    {
      String result = "";

      try {  
         
         System.out.println("After opening socket to server ");  
         os.writeBytes("GET " + script
            + " HTTP/1.0\r\n" 
            + "Accept: www/source\r\n"
            + "Accept: text/html\r\n"
            + "Accept: image/gif\r\n"
            + "Content-type: application/octet-stream\r\n"
            + "Content-length: " 
            + sdata.length() + "\r\n\r\n"); 
            //+ "\r\n\r\n"); 
         os.writeBytes(sdata); 

         System.out.println("Write ok..");

         //String line="";
         // while ((line = is.readLine()) != null)
         //  if (line.equals("CONTINUE")){
         //     System.out.println("I got BREAK the line   " +line) ; 
         //     break;
         //    }
         //System.out.println("I got the line   " +line) ; 
         //is.close();
         //os.close();
         //System.out.println("Read ok..");
      }

      catch (Exception e)
      {  
        if (s != null)
            try {
               s.close();
            }
            catch (IOException ex) {}
      }
      
   }
}

class read_from_http_server extends Thread{
   DataInputStream is;

   public read_from_http_server (network nt)
   {
     is = nt.is;
   }

   public void run  ()
   {
       String line = " ";
       byte chr;
     
       while(line != null)
	 {
	   
       try{
       while ((line = is.readLine()) != null)
            System.out.println(line);
       }catch (IOException ex) {}

       //while(!line.equals(""))
       //{
        // line = " "; 
        // System.out.println("I am reading from HTTP");
       //  try {
        //   while((chr = is.readByte()) != 0){
        //    line += Byte.toString(chr);
        //   }
        // }catch (IOException ex) {}
    //     System.out.println("I got the line   " +line) ;
          
         try {
               Thread.sleep(1000);
         }
         catch (InterruptedException ie) {break;}

         Thread.yield();
       }
    }
}

